#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum IngestType {
    #[serde(rename = "TABULAR")]
    Tabular,
    #[serde(rename = "MCAP")]
    Mcap,
    #[serde(rename = "DATAFLASH")]
    Dataflash,
    #[serde(rename = "JOURNAL_JSON")]
    JournalJson,
    #[serde(rename = "CONTAINERIZED")]
    Containerized,
    #[serde(rename = "VIDEO")]
    Video,
    #[serde(rename = "AVRO_STREAM")]
    AvroStream,
    #[serde(rename = "POINT_CLOUD")]
    PointCloud,
    #[serde(rename = "MULTI")]
    Multi,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl IngestType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            IngestType::Tabular => "TABULAR",
            IngestType::Mcap => "MCAP",
            IngestType::Dataflash => "DATAFLASH",
            IngestType::JournalJson => "JOURNAL_JSON",
            IngestType::Containerized => "CONTAINERIZED",
            IngestType::Video => "VIDEO",
            IngestType::AvroStream => "AVRO_STREAM",
            IngestType::PointCloud => "POINT_CLOUD",
            IngestType::Multi => "MULTI",
            IngestType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for IngestType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for IngestType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for IngestType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<IngestType, conjure_object::plain::ParseEnumError> {
        match v {
            "TABULAR" => Ok(IngestType::Tabular),
            "MCAP" => Ok(IngestType::Mcap),
            "DATAFLASH" => Ok(IngestType::Dataflash),
            "JOURNAL_JSON" => Ok(IngestType::JournalJson),
            "CONTAINERIZED" => Ok(IngestType::Containerized),
            "VIDEO" => Ok(IngestType::Video),
            "AVRO_STREAM" => Ok(IngestType::AvroStream),
            "POINT_CLOUD" => Ok(IngestType::PointCloud),
            "MULTI" => Ok(IngestType::Multi),
            v => v.parse().map(|v| IngestType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for IngestType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(v: &str) -> Result<IngestType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the IngestType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
